<!DOCTYPE html>
<html lang="en">
<head>
        <meta charset="utf-8" />
        <title>Linux And Chill - Devops</title>
        <link rel="stylesheet" href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/theme/css/main.css" />
        <link href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/feeds/all.atom.xml" type="application/atom+xml" rel="alternate" title="Linux And Chill Atom Feed" />
</head>

<body id="index" class="home">
        <header id="banner" class="body">
                <h1><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/">Linux And Chill </a></h1>
                <nav><ul>
                    <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/machine-learning.html">Machine Learning</a></li>
                    <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/system-administration.html">System Administration</a></li>
                </ul></nav>
        </header><!-- /#banner -->

            <aside id="featured" class="body">
                <article>
                    <h1 class="entry-title"><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/a-docker-primer.html">A Docker Primer</a></h1>
<footer class="post-info">
        <abbr class="published" title="2019-05-10T10:13:00-04:00">
                Published: Fri 10 May 2019
        </abbr>

        <address class="vcard author">
                By                         <a class="url fn" href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/author/timothy-pulliam.html">Timothy Pulliam</a>
        </address>
<p>In <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/system-administration.html">System Administration</a>.</p>
<p>tags: <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/tag/docker.html">Docker</a> <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/tag/devops.html">Devops</a> </p>
</footer><!-- /.post-info --><h2>Terminology</h2>
<h5>Image vs. Container</h5>
<p>A Docker image can be thought of as the blueprint for an OS that will be used to construct a container. An image is essentially how the the container will be configured, while a container is the actual running OS itself.</p>
<p>A single image can generate many containers.</p>
<h2>Installation</h2>
<p>The following is only for installing the docker community edition. For other
options installing Docker, see the <a href="https://docs.docker.com/install/">Docker Docs</a>.</p>
<p>Ubuntu</p>
<div class="highlight"><pre><span></span>apt-get update
apt-get install docker-ce
</pre></div>


<p>Redhat</p>
<div class="highlight"><pre><span></span>yum install docker-ce
</pre></div>


<p>Start the docker daemon</p>
<div class="highlight"><pre><span></span>systemctl start docker

systemctl enable docker
</pre></div>


<h2>Pulling Images From Docker Hub</h2>
<p>Community Images are uploaded to the <a href="https://hub.docker.com/">Docker Hub</a> where
anyone can pull them. The concept is very similar to source code and Github.</p>
<p>You can search for a particular image, say kali linux.</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker search kali
NAME                           DESCRIPTION                                     STARS               OFFICIAL            AUTOMATED
kalilinux/kali-linux-docker    Kali Linux Rolling Distribution Base Image      555                                     [OK]
linuxkonsult/kali-metasploit   Kali base image with metasploit                 68

...
</pre></div>


<p>Pull the one with the most stars, or the official one. Whichever.</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker pull kalilinux/kali-linux-docker

Using default tag: latest
latest: Pulling from kalilinux/kali-linux-docker
014a6d74f96c: Pull complete
9febb14563a0: Pull complete
c38f04972c6b: Pull complete
9d39d049d5d0: Pull complete
4e80058918bf: Pull complete
ccd85f0810ad: Pull complete
6ab25bddb799: Pull complete
789ba1ebcb41: Pull complete
524584107b55: Pull complete
40a1af1b9680: Pull complete
fb6edc730b9f: Pull complete
270f87c17cf3: Pull complete
8159e4fffac9: Pull complete
01d3dc4e9fe9: Pull complete
a386beee6e20: Pull complete
46fa80bd0f33: Pull complete
2d3ff71a091d: Pull complete
6f41a333af7c: Pull complete
Digest: sha256:7f1253cba663662d78c121369e23d6c0b58b7b95de268886ecfdb73b003a3bd8
Status: Downloaded newer image for kalilinux/kali-linux-docker:latest
</pre></div>


<p>We can see the kali linux image has been added to the list of images.</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker images
REPOSITORY                    TAG                 IMAGE ID            CREATED             SIZE
kalilinux/kali-linux-docker   latest              f26f3ae90aee        2 months ago        1.57GB
</pre></div>


<h2>Running An Instance/Container</h2>
<p>There are two ways to run a container. You can run a container interactively,
where you have access to the shell</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker run -t -i kalilinux/kali-linux-docker /bin/bash
root@f157bf90bca9:/#
</pre></div>


<p>Or you can instruct the container to run a single command and then terminate</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker run kalilinux/kali-linux-docker echo &quot;hello docker&quot;
hello docker
</pre></div>


<p>To view all running and stopped containers use the <code>docker ps -a</code> command. If
you only want to see running containers (and not stopped/terminated ones) ommit
the <code>-a</code> flag.</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker ps -a
CONTAINER ID        IMAGE                         COMMAND             CREATED              STATUS              PORTS               NAMES
f157bf90bca9        kalilinux/kali-linux-docker   &quot;/bin/bash&quot;         About a minute ago   Up About a minute                       objective_golick
37be294f38ab        kalilinux/kali-linux-docker   &quot;echo &#39;hello docker&#39;&quot;   39 seconds ago      Exited (0) 37 seconds ago                       elegant_mccarthy
</pre></div>


<p>If we need to reattach to the container, we can do so by specifying the container
name or id.</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker attach objective_golick
root@f157bf90bca9:/#
</pre></div>


<p>To stop and remove a running instance run the below commands (you can interchange container name and id). You can verify the containers have been removed by running
<code>docker ps -a</code>.</p>
<div class="highlight"><pre><span></span>tpulliam@lappy:~$ docker stop objective_golick
objective_golick
tpulliam@lappy:~$ docker rm f157bf90bca9
f157bf90bca9
</pre></div>                </article>
            </aside><!-- /#featured -->
        <section id="extras" class="body">
                <div class="blogroll">
                        <h2>links</h2>
                        <ul>
                            <li><a href="http://getpelican.com/">Pelican</a></li>
                            <li><a href="http://python.org/">Python.org</a></li>
                            <li><a href="http://jinja.pocoo.org/">Jinja2</a></li>
                        </ul>
                </div><!-- /.blogroll -->
                <div class="social">
                        <h2>social</h2>
                        <ul>
                            <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/feeds/all.atom.xml" type="application/atom+xml" rel="alternate">atom feed</a></li>

                            <li><a href="https://linkedin.com/in/timothy-pulliam">LinkedIn</a></li>
                            <li><a href="https://github.com/Timothy-Pulliam">Github</a></li>
                            <li><a href="https://www.youtube.com/channel/UC0G4YCuFJukeTicFBO6u4-A?view_as=subscriber">YouTube</a></li>
                        </ul>
                </div><!-- /.social -->
        </section><!-- /#extras -->

        <footer id="contentinfo" class="body">
                <address id="about" class="vcard body">
                Proudly powered by <a href="http://getpelican.com/">Pelican</a>, which takes great advantage of <a href="http://python.org">Python</a>.
                </address><!-- /#about -->

                <p>The theme is by <a href="http://coding.smashingmagazine.com/2009/08/04/designing-a-html-5-layout-from-scratch/">Smashing Magazine</a>, thanks!</p>
        </footer><!-- /#contentinfo -->

</body>
</html>